using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using ppsGrid;

namespace grdDemo.frm{
	/// <summary>
	/// Summary description for frmAdr.
	/// </summary>
	public class frmAdr:System.Windows.Forms.Form{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Splitter splSplitter;
		internal System.Windows.Forms.TextBox txtFax;
		private ppsGrid.GridCol colInternet;
		private System.Windows.Forms.Label labMobil;
		private ppsGrid.GridCol colStadt;
		private System.Windows.Forms.Panel pnlListe;
		private System.Windows.Forms.MenuItem mnuCut;
		private ppsGrid.GridCol colNachname;
		internal System.Windows.Forms.DateTimePicker dteGeburtstag;
		internal System.Windows.Forms.TextBox txtMobil;
		private System.Windows.Forms.GroupBox fraAdr;
		internal System.Windows.Forms.TextBox txtNachname;
		private System.Windows.Forms.Label labInternet;
		internal System.Windows.Forms.TextBox txtStadt;
		private ppsGrid.GridCol colMittelfeld;
		private System.Windows.Forms.Button btnSave;
		private ppsGrid.GridCol colPLZ;
		private System.Windows.Forms.MenuItem mnuDelete;
		private System.Windows.Forms.Panel pnlAdr;
		private System.Windows.Forms.MenuItem mnuPaste;
		internal System.Windows.Forms.TextBox txtTelefon;
		internal System.Windows.Forms.TextBox txtVorname;
		private System.Windows.Forms.Label labFax;
		private ppsGrid.GridCol colStrasse;
		private System.Windows.Forms.Label LabMittelfeld;
		internal System.Windows.Forms.TextBox txtPLZ;
		private ppsGrid.Grid grdList;
		private System.Windows.Forms.MenuItem mnuEdit;
		private ppsGrid.GridCol colPostfach;
		private ppsGrid.GridCol colMobil;
		private System.Windows.Forms.GroupBox fraAnschrift;
		private System.Windows.Forms.MenuItem mnuNew;
		private ppsGrid.GridCol colEMail;
		internal System.Windows.Forms.TextBox txtPostfach;
		internal System.Windows.Forms.TextBox txtMittelfeld;
		private System.Windows.Forms.Label labStrasse;
		private System.Windows.Forms.Label labEmail;
		private ppsGrid.GridCol colGeburtstag;
		private System.Windows.Forms.Label labNachname;
		private ppsGrid.GridRow rowLast;
		internal System.Windows.Forms.ContextMenu mnuListe;
		private System.Windows.Forms.GroupBox fraKomm;
		private System.Windows.Forms.MenuItem mnuCopy;
		private ppsGrid.GridCol colNo;
		private System.Windows.Forms.ImageList imgImages;
		internal System.Windows.Forms.TextBox txtEmail;
		internal System.Windows.Forms.TextBox txtStrasse;
		private ppsGrid.GridCol colTelefon;
		private ppsGrid.GridCol colVorname;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.Label labVorname;
		internal System.Windows.Forms.TextBox txtInternet;
		private System.Windows.Forms.Label labGeburtstag;
		private ppsGrid.GridRow rowTitle;
		private System.Windows.Forms.Label labTelefon;
		private ppsGrid.GridCol colFax;
		private System.Windows.Forms.Label labStadt;
		private System.Windows.Forms.GroupBox fraSonstiges;
		private System.Windows.Forms.Label labPostfach;
		private System.Windows.Forms.Label labPLZ;
		private clsAdr	vCurrAdr;
		private bool		vChanged;


		public frmAdr(){
			InitializeComponent();
			vCurrAdr=null;
		}

		public void Init(){
			for(int c=grdList.FixedColCount;c<grdList.Cols.Count;c++)
				grdList.Cells[c,0].Value=grdList.Cols[c].Name.Substring(3);
			this.DoLoad();
			grdList.Rows[grdList.FixedRowCount].Selected=true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing){
			if(disposing)
				if(components!=null)
					components.Dispose();
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmAdr));
			this.labPLZ = new System.Windows.Forms.Label();
			this.labPostfach = new System.Windows.Forms.Label();
			this.fraSonstiges = new System.Windows.Forms.GroupBox();
			this.labStadt = new System.Windows.Forms.Label();
			this.colFax = new ppsGrid.GridCol();
			this.labTelefon = new System.Windows.Forms.Label();
			this.rowTitle = new ppsGrid.GridRow();
			this.labGeburtstag = new System.Windows.Forms.Label();
			this.txtInternet = new System.Windows.Forms.TextBox();
			this.labVorname = new System.Windows.Forms.Label();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.colVorname = new ppsGrid.GridCol();
			this.colTelefon = new ppsGrid.GridCol();
			this.txtStrasse = new System.Windows.Forms.TextBox();
			this.txtEmail = new System.Windows.Forms.TextBox();
			this.imgImages = new System.Windows.Forms.ImageList(this.components);
			this.colNo = new ppsGrid.GridCol();
			this.mnuCopy = new System.Windows.Forms.MenuItem();
			this.fraKomm = new System.Windows.Forms.GroupBox();
			this.mnuListe = new System.Windows.Forms.ContextMenu();
			this.rowLast = new ppsGrid.GridRow();
			this.labNachname = new System.Windows.Forms.Label();
			this.colGeburtstag = new ppsGrid.GridCol();
			this.labEmail = new System.Windows.Forms.Label();
			this.labStrasse = new System.Windows.Forms.Label();
			this.txtMittelfeld = new System.Windows.Forms.TextBox();
			this.txtPostfach = new System.Windows.Forms.TextBox();
			this.colEMail = new ppsGrid.GridCol();
			this.mnuNew = new System.Windows.Forms.MenuItem();
			this.fraAnschrift = new System.Windows.Forms.GroupBox();
			this.colMobil = new ppsGrid.GridCol();
			this.colPostfach = new ppsGrid.GridCol();
			this.mnuEdit = new System.Windows.Forms.MenuItem();
			this.grdList = new ppsGrid.Grid();
			this.txtPLZ = new System.Windows.Forms.TextBox();
			this.LabMittelfeld = new System.Windows.Forms.Label();
			this.colStrasse = new ppsGrid.GridCol();
			this.labFax = new System.Windows.Forms.Label();
			this.txtVorname = new System.Windows.Forms.TextBox();
			this.txtTelefon = new System.Windows.Forms.TextBox();
			this.mnuPaste = new System.Windows.Forms.MenuItem();
			this.pnlAdr = new System.Windows.Forms.Panel();
			this.mnuDelete = new System.Windows.Forms.MenuItem();
			this.colPLZ = new ppsGrid.GridCol();
			this.btnSave = new System.Windows.Forms.Button();
			this.colMittelfeld = new ppsGrid.GridCol();
			this.txtStadt = new System.Windows.Forms.TextBox();
			this.labInternet = new System.Windows.Forms.Label();
			this.txtNachname = new System.Windows.Forms.TextBox();
			this.fraAdr = new System.Windows.Forms.GroupBox();
			this.txtMobil = new System.Windows.Forms.TextBox();
			this.dteGeburtstag = new System.Windows.Forms.DateTimePicker();
			this.colNachname = new ppsGrid.GridCol();
			this.mnuCut = new System.Windows.Forms.MenuItem();
			this.pnlListe = new System.Windows.Forms.Panel();
			this.colStadt = new ppsGrid.GridCol();
			this.labMobil = new System.Windows.Forms.Label();
			this.colInternet = new ppsGrid.GridCol();
			this.txtFax = new System.Windows.Forms.TextBox();
			this.splSplitter = new System.Windows.Forms.Splitter();
			this.fraSonstiges.SuspendLayout();
			this.fraKomm.SuspendLayout();
			this.fraAnschrift.SuspendLayout();
			this.pnlAdr.SuspendLayout();
			this.fraAdr.SuspendLayout();
			this.pnlListe.SuspendLayout();
			this.SuspendLayout();
			// 
			// labPLZ
			// 
			this.labPLZ.Location = new System.Drawing.Point(8, 48);
			this.labPLZ.Name = "labPLZ";
			this.labPLZ.Size = new System.Drawing.Size(68, 16);
			this.labPLZ.TabIndex = 2;
			this.labPLZ.Text = "&PLZ";
			// 
			// labPostfach
			// 
			this.labPostfach.Location = new System.Drawing.Point(8, 72);
			this.labPostfach.Name = "labPostfach";
			this.labPostfach.Size = new System.Drawing.Size(68, 16);
			this.labPostfach.TabIndex = 6;
			this.labPostfach.Text = "&Postfach";
			// 
			// fraSonstiges
			// 
			this.fraSonstiges.Controls.Add(this.btnSave);
			this.fraSonstiges.Controls.Add(this.dteGeburtstag);
			this.fraSonstiges.Controls.Add(this.labGeburtstag);
			this.fraSonstiges.Location = new System.Drawing.Point(292, 160);
			this.fraSonstiges.Name = "fraSonstiges";
			this.fraSonstiges.Size = new System.Drawing.Size(236, 60);
			this.fraSonstiges.TabIndex = 3;
			this.fraSonstiges.TabStop = false;
			this.fraSonstiges.Text = "Sonstiges";
			// 
			// labStadt
			// 
			this.labStadt.Location = new System.Drawing.Point(116, 48);
			this.labStadt.Name = "labStadt";
			this.labStadt.Size = new System.Drawing.Size(44, 16);
			this.labStadt.TabIndex = 4;
			this.labStadt.Text = "Stadt";
			this.labStadt.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// colFax
			// 
			this.colFax.Name = "colFax";
			// 
			// labTelefon
			// 
			this.labTelefon.Location = new System.Drawing.Point(8, 28);
			this.labTelefon.Name = "labTelefon";
			this.labTelefon.Size = new System.Drawing.Size(68, 16);
			this.labTelefon.TabIndex = 0;
			this.labTelefon.Text = "&Telefon";
			// 
			// rowTitle
			// 
			this.rowTitle.Fixed = true;
			this.rowTitle.Name = "rowTitle";
			// 
			// labGeburtstag
			// 
			this.labGeburtstag.Location = new System.Drawing.Point(8, 28);
			this.labGeburtstag.Name = "labGeburtstag";
			this.labGeburtstag.Size = new System.Drawing.Size(72, 16);
			this.labGeburtstag.TabIndex = 0;
			this.labGeburtstag.Text = "&Geburtstag";
			// 
			// txtInternet
			// 
			this.txtInternet.Location = new System.Drawing.Point(60, 96);
			this.txtInternet.MaxLength = 25;
			this.txtInternet.Name = "txtInternet";
			this.txtInternet.Size = new System.Drawing.Size(164, 23);
			this.txtInternet.TabIndex = 7;
			this.txtInternet.Text = "";
			this.txtInternet.Validating += new System.ComponentModel.CancelEventHandler(this.txt_Validating);
			// 
			// labVorname
			// 
			this.labVorname.Location = new System.Drawing.Point(8, 28);
			this.labVorname.Name = "labVorname";
			this.labVorname.Size = new System.Drawing.Size(68, 16);
			this.labVorname.TabIndex = 0;
			this.labVorname.Text = "&Vorname";
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 4;
			this.menuItem5.Text = "-";
			// 
			// colVorname
			// 
			this.colVorname.Name = "colVorname";
			// 
			// colTelefon
			// 
			this.colTelefon.Name = "colTelefon";
			// 
			// txtStrasse
			// 
			this.txtStrasse.Location = new System.Drawing.Point(72, 20);
			this.txtStrasse.MaxLength = 15;
			this.txtStrasse.Name = "txtStrasse";
			this.txtStrasse.Size = new System.Drawing.Size(200, 23);
			this.txtStrasse.TabIndex = 1;
			this.txtStrasse.Text = "";
			this.txtStrasse.Validating += new System.ComponentModel.CancelEventHandler(this.txt_Validating);
			// 
			// txtEmail
			// 
			this.txtEmail.Location = new System.Drawing.Point(60, 120);
			this.txtEmail.MaxLength = 25;
			this.txtEmail.Name = "txtEmail";
			this.txtEmail.Size = new System.Drawing.Size(164, 23);
			this.txtEmail.TabIndex = 9;
			this.txtEmail.Text = "";
			this.txtEmail.Validating += new System.ComponentModel.CancelEventHandler(this.txt_Validating);
			// 
			// imgImages
			// 
			this.imgImages.ImageSize = new System.Drawing.Size(16, 16);
			this.imgImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgImages.ImageStream")));
			this.imgImages.TransparentColor = System.Drawing.SystemColors.Window;
			// 
			// colNo
			// 
			this.colNo.AutoNumber = true;
			this.colNo.Fixed = true;
			this.colNo.Name = "colNo";
			// 
			// mnuCopy
			// 
			this.mnuCopy.Index = 1;
			this.mnuCopy.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
			this.mnuCopy.Text = "Kopieren";
			this.mnuCopy.Click += new System.EventHandler(this.mnuCopy_Click);
			// 
			// fraKomm
			// 
			this.fraKomm.Controls.Add(this.txtEmail);
			this.fraKomm.Controls.Add(this.labEmail);
			this.fraKomm.Controls.Add(this.txtInternet);
			this.fraKomm.Controls.Add(this.labInternet);
			this.fraKomm.Controls.Add(this.txtFax);
			this.fraKomm.Controls.Add(this.labFax);
			this.fraKomm.Controls.Add(this.txtTelefon);
			this.fraKomm.Controls.Add(this.labTelefon);
			this.fraKomm.Controls.Add(this.txtMobil);
			this.fraKomm.Controls.Add(this.labMobil);
			this.fraKomm.Location = new System.Drawing.Point(292, 0);
			this.fraKomm.Name = "fraKomm";
			this.fraKomm.Size = new System.Drawing.Size(236, 156);
			this.fraKomm.TabIndex = 2;
			this.fraKomm.TabStop = false;
			this.fraKomm.Text = "Kommunikation";
			// 
			// mnuListe
			// 
			this.mnuListe.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.mnuCut,
						this.mnuCopy,
						this.mnuPaste,
						this.mnuDelete,
						this.menuItem5,
						this.mnuNew,
						this.mnuEdit});
			this.mnuListe.Popup += new System.EventHandler(this.mnuListe_Popup);
			// 
			// rowLast
			// 
			this.rowLast.Name = "rowLast";
			// 
			// labNachname
			// 
			this.labNachname.Location = new System.Drawing.Point(8, 52);
			this.labNachname.Name = "labNachname";
			this.labNachname.Size = new System.Drawing.Size(68, 16);
			this.labNachname.TabIndex = 2;
			this.labNachname.Text = "&Nachname";
			// 
			// colGeburtstag
			// 
			this.colGeburtstag.FormatString = "dd.MM.yyyy";
			this.colGeburtstag.Name = "colGeburtstag";
			// 
			// labEmail
			// 
			this.labEmail.Location = new System.Drawing.Point(8, 124);
			this.labEmail.Name = "labEmail";
			this.labEmail.Size = new System.Drawing.Size(68, 16);
			this.labEmail.TabIndex = 8;
			this.labEmail.Text = "&E-Mail";
			// 
			// labStrasse
			// 
			this.labStrasse.Location = new System.Drawing.Point(8, 24);
			this.labStrasse.Name = "labStrasse";
			this.labStrasse.Size = new System.Drawing.Size(68, 16);
			this.labStrasse.TabIndex = 0;
			this.labStrasse.Text = "Strae";
			// 
			// txtMittelfeld
			// 
			this.txtMittelfeld.Location = new System.Drawing.Point(88, 72);
			this.txtMittelfeld.MaxLength = 15;
			this.txtMittelfeld.Name = "txtMittelfeld";
			this.txtMittelfeld.Size = new System.Drawing.Size(184, 23);
			this.txtMittelfeld.TabIndex = 5;
			this.txtMittelfeld.Text = "";
			this.txtMittelfeld.Validating += new System.ComponentModel.CancelEventHandler(this.txt_Validating);
			// 
			// txtPostfach
			// 
			this.txtPostfach.Location = new System.Drawing.Point(72, 68);
			this.txtPostfach.MaxLength = 15;
			this.txtPostfach.Name = "txtPostfach";
			this.txtPostfach.Size = new System.Drawing.Size(200, 23);
			this.txtPostfach.TabIndex = 7;
			this.txtPostfach.Text = "";
			this.txtPostfach.Validating += new System.ComponentModel.CancelEventHandler(this.txt_Validating);
			// 
			// colEMail
			// 
			this.colEMail.Name = "colEMail";
			// 
			// mnuNew
			// 
			this.mnuNew.Index = 5;
			this.mnuNew.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
			this.mnuNew.Text = "Neu";
			this.mnuNew.Click += new System.EventHandler(this.mnuNew_Click);
			// 
			// fraAnschrift
			// 
			this.fraAnschrift.Controls.Add(this.txtPLZ);
			this.fraAnschrift.Controls.Add(this.labPLZ);
			this.fraAnschrift.Controls.Add(this.txtStrasse);
			this.fraAnschrift.Controls.Add(this.labStrasse);
			this.fraAnschrift.Controls.Add(this.txtPostfach);
			this.fraAnschrift.Controls.Add(this.labPostfach);
			this.fraAnschrift.Controls.Add(this.labStadt);
			this.fraAnschrift.Controls.Add(this.txtStadt);
			this.fraAnschrift.Location = new System.Drawing.Point(4, 116);
			this.fraAnschrift.Name = "fraAnschrift";
			this.fraAnschrift.Size = new System.Drawing.Size(280, 104);
			this.fraAnschrift.TabIndex = 1;
			this.fraAnschrift.TabStop = false;
			this.fraAnschrift.Text = "An&schrift";
			// 
			// colMobil
			// 
			this.colMobil.Name = "colMobil";
			// 
			// colPostfach
			// 
			this.colPostfach.Name = "colPostfach";
			// 
			// mnuEdit
			// 
			this.mnuEdit.Index = 6;
			this.mnuEdit.Shortcut = System.Windows.Forms.Shortcut.CtrlE;
			this.mnuEdit.Text = "ndern";
			this.mnuEdit.Click += new System.EventHandler(this.mnuEdit_Click);
			// 
			// grdList
			// 
			this.grdList.BackColorCell = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(255)));
			this.grdList.BackColorCellGradient = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.grdList.BackColorFixedGradient = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(0)), ((System.Byte)(192)));
			this.grdList.BackColorRowAlternate = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(192)), ((System.Byte)(255)));
			this.grdList.CellFrameType = ppsGrid.eCellFrameType.Horiz;
			this.grdList.CellFrameWidth = 2;
			this.grdList.CellGradientMode = ppsGrid.eGradientMode.ForwardDiagonal;
			this.grdList.CellHomeVisible = true;
			this.grdList.Cols.AddRange(new object[] {
						this.colNo,
						this.colVorname,
						this.colNachname,
						this.colMittelfeld,
						this.colStrasse,
						this.colPLZ,
						this.colStadt,
						this.colPostfach,
						this.colTelefon,
						this.colFax,
						this.colMobil,
						this.colInternet,
						this.colEMail,
						this.colGeburtstag});
			this.grdList.ContextMenu = this.mnuListe;
			this.grdList.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grdList.FixedColType = ((ppsGrid.eFixedColType)(((ppsGrid.eFixedColType.Sortable | ppsGrid.eFixedColType.Moveable) 
						| ppsGrid.eFixedColType.Sizeable)));
			this.grdList.FixedGradientMode = ppsGrid.eGradientMode.ForwardDiagonal;
			this.grdList.FixedRowType = ((ppsGrid.eFixedRowType)((ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable)));
			this.grdList.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.grdList.HideSelection = ppsGrid.eHighlight.None;
			this.grdList.Location = new System.Drawing.Point(0, 0);
			this.grdList.Name = "grdList";
			this.grdList.Rows.AddRange(new object[] {
						this.rowTitle,
						this.rowLast});
			this.grdList.Scrollbar = ppsGrid.eScrollbar.Both;
			this.grdList.ScrollbarVisible = ppsGrid.eScrollbarVisible.Required;
			this.grdList.Size = new System.Drawing.Size(598, 135);
			this.grdList.StringAlignVert = ppsGrid.eContentAlign.Center;
			this.grdList.TabIndex = 0;
			this.grdList.AfterSelectionChange += new ppsGrid.OnAfterSelectionChange(this.grdList_AfterSelectionChange);
			this.grdList.BeforeColumnSort += new ppsGrid.OnBeforeColumnSort(this.grdList_BeforeColumnSort);
			this.grdList.AfterColumnSort += new ppsGrid.OnAfterColumnSort(this.grdList_AfterColumnSort);
			this.grdList.BeforeRowMove += new ppsGrid.OnBeforeRowMove(this.grdList_BeforeRowMove);
			// 
			// txtPLZ
			// 
			this.txtPLZ.Location = new System.Drawing.Point(72, 44);
			this.txtPLZ.MaxLength = 6;
			this.txtPLZ.Name = "txtPLZ";
			this.txtPLZ.Size = new System.Drawing.Size(48, 23);
			this.txtPLZ.TabIndex = 3;
			this.txtPLZ.Text = "";
			this.txtPLZ.Validating += new System.ComponentModel.CancelEventHandler(this.txt_Validating);
			// 
			// LabMittelfeld
			// 
			this.LabMittelfeld.Location = new System.Drawing.Point(8, 76);
			this.LabMittelfeld.Name = "LabMittelfeld";
			this.LabMittelfeld.Size = new System.Drawing.Size(68, 16);
			this.LabMittelfeld.TabIndex = 4;
			this.LabMittelfeld.Text = "&Mittelfeld";
			// 
			// colStrasse
			// 
			this.colStrasse.Name = "colStrasse";
			// 
			// labFax
			// 
			this.labFax.Location = new System.Drawing.Point(8, 52);
			this.labFax.Name = "labFax";
			this.labFax.Size = new System.Drawing.Size(68, 16);
			this.labFax.TabIndex = 2;
			this.labFax.Text = "Fa&x";
			// 
			// txtVorname
			// 
			this.txtVorname.Location = new System.Drawing.Point(88, 24);
			this.txtVorname.MaxLength = 15;
			this.txtVorname.Name = "txtVorname";
			this.txtVorname.Size = new System.Drawing.Size(184, 23);
			this.txtVorname.TabIndex = 1;
			this.txtVorname.Text = "";
			this.txtVorname.Validating += new System.ComponentModel.CancelEventHandler(this.txt_Validating);
			// 
			// txtTelefon
			// 
			this.txtTelefon.Location = new System.Drawing.Point(60, 24);
			this.txtTelefon.MaxLength = 15;
			this.txtTelefon.Name = "txtTelefon";
			this.txtTelefon.Size = new System.Drawing.Size(164, 23);
			this.txtTelefon.TabIndex = 1;
			this.txtTelefon.Text = "";
			this.txtTelefon.Validating += new System.ComponentModel.CancelEventHandler(this.txt_Validating);
			// 
			// mnuPaste
			// 
			this.mnuPaste.Index = 2;
			this.mnuPaste.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
			this.mnuPaste.Text = "Einfgen";
			this.mnuPaste.Click += new System.EventHandler(this.mnuPaste_Click);
			// 
			// pnlAdr
			// 
			this.pnlAdr.Controls.Add(this.fraAnschrift);
			this.pnlAdr.Controls.Add(this.fraSonstiges);
			this.pnlAdr.Controls.Add(this.fraKomm);
			this.pnlAdr.Controls.Add(this.fraAdr);
			this.pnlAdr.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlAdr.Location = new System.Drawing.Point(0, 143);
			this.pnlAdr.Name = "pnlAdr";
			this.pnlAdr.Size = new System.Drawing.Size(598, 228);
			this.pnlAdr.TabIndex = 2;
			// 
			// mnuDelete
			// 
			this.mnuDelete.Index = 3;
			this.mnuDelete.Text = "Lschen";
			this.mnuDelete.Click += new System.EventHandler(this.mnuDelete_Click);
			// 
			// colPLZ
			// 
			this.colPLZ.Name = "colPLZ";
			// 
			// btnSave
			// 
			this.btnSave.ImageIndex = 0;
			this.btnSave.ImageList = this.imgImages;
			this.btnSave.Location = new System.Drawing.Point(204, 32);
			this.btnSave.Name = "btnSave";
			this.btnSave.Size = new System.Drawing.Size(28, 24);
			this.btnSave.TabIndex = 2;
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			// 
			// colMittelfeld
			// 
			this.colMittelfeld.Name = "colMittelfeld";
			// 
			// txtStadt
			// 
			this.txtStadt.Location = new System.Drawing.Point(164, 44);
			this.txtStadt.MaxLength = 15;
			this.txtStadt.Name = "txtStadt";
			this.txtStadt.Size = new System.Drawing.Size(108, 23);
			this.txtStadt.TabIndex = 5;
			this.txtStadt.Text = "";
			this.txtStadt.Validating += new System.ComponentModel.CancelEventHandler(this.txt_Validating);
			// 
			// labInternet
			// 
			this.labInternet.Location = new System.Drawing.Point(8, 100);
			this.labInternet.Name = "labInternet";
			this.labInternet.Size = new System.Drawing.Size(68, 16);
			this.labInternet.TabIndex = 6;
			this.labInternet.Text = "&Internet";
			// 
			// txtNachname
			// 
			this.txtNachname.Location = new System.Drawing.Point(88, 48);
			this.txtNachname.MaxLength = 15;
			this.txtNachname.Name = "txtNachname";
			this.txtNachname.Size = new System.Drawing.Size(184, 23);
			this.txtNachname.TabIndex = 3;
			this.txtNachname.Text = "";
			this.txtNachname.Validating += new System.ComponentModel.CancelEventHandler(this.txt_Validating);
			// 
			// fraAdr
			// 
			this.fraAdr.Controls.Add(this.txtNachname);
			this.fraAdr.Controls.Add(this.labNachname);
			this.fraAdr.Controls.Add(this.txtVorname);
			this.fraAdr.Controls.Add(this.labVorname);
			this.fraAdr.Controls.Add(this.txtMittelfeld);
			this.fraAdr.Controls.Add(this.LabMittelfeld);
			this.fraAdr.Location = new System.Drawing.Point(4, 0);
			this.fraAdr.Name = "fraAdr";
			this.fraAdr.Size = new System.Drawing.Size(280, 108);
			this.fraAdr.TabIndex = 0;
			this.fraAdr.TabStop = false;
			this.fraAdr.Text = "Adresse";
			// 
			// txtMobil
			// 
			this.txtMobil.Location = new System.Drawing.Point(60, 72);
			this.txtMobil.MaxLength = 15;
			this.txtMobil.Name = "txtMobil";
			this.txtMobil.Size = new System.Drawing.Size(164, 23);
			this.txtMobil.TabIndex = 5;
			this.txtMobil.Text = "";
			this.txtMobil.Validating += new System.ComponentModel.CancelEventHandler(this.txt_Validating);
			// 
			// dteGeburtstag
			// 
			this.dteGeburtstag.CustomFormat = "dd.MMM.yyyy";
			this.dteGeburtstag.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dteGeburtstag.Location = new System.Drawing.Point(80, 24);
			this.dteGeburtstag.MaxDate = new System.DateTime(2009, 12, 31, 0, 0, 0, 0);
			this.dteGeburtstag.MinDate = new System.DateTime(1900, 1, 1, 0, 0, 0, 0);
			this.dteGeburtstag.Name = "dteGeburtstag";
			this.dteGeburtstag.Size = new System.Drawing.Size(100, 23);
			this.dteGeburtstag.TabIndex = 1;
			this.dteGeburtstag.Validating += new System.ComponentModel.CancelEventHandler(this.txt_Validating);
			// 
			// colNachname
			// 
			this.colNachname.Name = "colNachname";
			// 
			// mnuCut
			// 
			this.mnuCut.Index = 0;
			this.mnuCut.Shortcut = System.Windows.Forms.Shortcut.CtrlX;
			this.mnuCut.Text = "Ausschneiden";
			this.mnuCut.Click += new System.EventHandler(this.mnuCut_Click);
			// 
			// pnlListe
			// 
			this.pnlListe.Controls.Add(this.grdList);
			this.pnlListe.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlListe.Location = new System.Drawing.Point(0, 0);
			this.pnlListe.Name = "pnlListe";
			this.pnlListe.Size = new System.Drawing.Size(598, 135);
			this.pnlListe.TabIndex = 0;
			// 
			// colStadt
			// 
			this.colStadt.Name = "colStadt";
			// 
			// labMobil
			// 
			this.labMobil.Location = new System.Drawing.Point(8, 76);
			this.labMobil.Name = "labMobil";
			this.labMobil.Size = new System.Drawing.Size(68, 16);
			this.labMobil.TabIndex = 4;
			this.labMobil.Text = "M&obil";
			// 
			// colInternet
			// 
			this.colInternet.Name = "colInternet";
			// 
			// txtFax
			// 
			this.txtFax.Location = new System.Drawing.Point(60, 48);
			this.txtFax.MaxLength = 15;
			this.txtFax.Name = "txtFax";
			this.txtFax.Size = new System.Drawing.Size(164, 23);
			this.txtFax.TabIndex = 3;
			this.txtFax.Text = "";
			this.txtFax.Validating += new System.ComponentModel.CancelEventHandler(this.txt_Validating);
			// 
			// splSplitter
			// 
			this.splSplitter.BackColor = System.Drawing.Color.LightGray;
			this.splSplitter.Cursor = System.Windows.Forms.Cursors.HSplit;
			this.splSplitter.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splSplitter.Location = new System.Drawing.Point(0, 135);
			this.splSplitter.Name = "splSplitter";
			this.splSplitter.Size = new System.Drawing.Size(598, 8);
			this.splSplitter.TabIndex = 1;
			this.splSplitter.TabStop = false;
			// 
			// frmAdr
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 16);
			this.ClientSize = new System.Drawing.Size(604, 377);
			this.Controls.Add(this.pnlListe);
			this.Controls.Add(this.splSplitter);
			this.Controls.Add(this.pnlAdr);
			this.DockPadding.Bottom = 6;
			this.DockPadding.Right = 6;
			this.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "frmAdr";
			this.Text = "Adressen";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmAdr_Closing);
			this.fraSonstiges.ResumeLayout(false);
			this.fraKomm.ResumeLayout(false);
			this.fraAnschrift.ResumeLayout(false);
			this.pnlAdr.ResumeLayout(false);
			this.fraAdr.ResumeLayout(false);
			this.pnlListe.ResumeLayout(false);
			this.ResumeLayout(false);
		}
		#endregion

		/// <summary>Adressfenster schlieen, speichern ?</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void frmAdr_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
			if(vChanged){
				MessageBoxButtons				btn=MessageBoxButtons.YesNoCancel;
				MessageBoxIcon					icn=MessageBoxIcon.Exclamation;
				MessageBoxDefaultButton	dft=MessageBoxDefaultButton.Button1;
				DialogResult						dlg;
				string									msg="nderungen speichern ?";

				dlg=MessageBox.Show(this,msg,"Speichern...",btn,icn,dft);			// speichern ?
				if(dlg==DialogResult.Yes)																			// ..ja, speichern
					btnSave_Click(this,new EventArgs());												// ..doit
				if(dlg==DialogResult.Cancel)																	// ..nein, abbruch
					e.Cancel=true;																							// ..form offen lassen
			}
		}

		/// <summary>Adressen laden</summary>
		private void DoLoad(){
			clsAdr					adr;
			string					pth=System.Environment.CurrentDirectory+@"\tblAdr.dat";
			BinaryFormatter	bin=new BinaryFormatter();
			int							cnt;

			try{
				FileStream			fs=new FileStream(pth,FileMode.Open);					// datei ffnen
				cnt=(int)bin.Deserialize(fs);																	// anzahl der adressen
				grdList.AddRows(cnt,grdList.FixedRowCount);										// alle zeilen erzeugen
				for(int rw=0;rw<cnt;rw++){																		// alle..
					adr=(clsAdr)bin.Deserialize(fs);														// ..adressen lesen
					adr.Display(grdList,grdList.FixedRowCount+rw);							// ..und anzeigen
				}
				fs.Close();																										// datei schlieen
				vChanged=false;																								// keine nderungen vorhanden
			}
			catch{}
		}

		/// <summary>alle adressen speichern</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void btnSave_Click(object sender, System.EventArgs e) {
			clsAdr					adr;
			int							cnt=grdList.Rows.Count-grdList.FixedRowCount-1;
			string					pth=System.Environment.CurrentDirectory+@"\tblAdr.dat";
			BinaryFormatter	bin=new BinaryFormatter();
			FileStream			fs=new FileStream(pth,FileMode.OpenOrCreate);		// datei ffnen

			bin.Serialize(fs,cnt);																					// anzahl der adressen speichern
			for(int rw=0;rw<grdList.Rows.Count;rw++)												// alle..
				if(grdList.Rows[rw].Tag!=null){																// ..adressen
					adr=(grdList.Rows[rw].Tag as clsAdr);												// ..speichern
					bin.Serialize(fs,adr);																			
				}
			fs.Close();																											// datei schlieen
			vChanged=false;																									// keine nderungen mehr
		}

		/// <summary>event: textbox order dateTimePicker gendert</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void txt_Validating(object sender, System.ComponentModel.CancelEventArgs e) {
			bool	ok=false;
			int		rw;

			if(sender.GetType()==typeof(TextBox)){
				if(((TextBox)sender).Text!="")	ok=true;											// textbox modified ?
			}
			else 
				if(sender.GetType()==typeof( DateTimePicker))	ok=true;				// dateTimePicker modified

			if(ok){																													// modified ?
				if(vCurrAdr==null){																						// modus adresse neu ?
					rw=grdList.Rows["rowLast"].Row;															// letzte zeile
					grdList.AddRows(1,rw);																			// ..neue zeile einfgen
					vCurrAdr=new clsAdr();																			// ..neue adresse erzeugen
					vCurrAdr.Modify(this);																			// adressnderungen einlesen
					vCurrAdr.Display(grdList,rw);																// ..und anzeigen in liste
//				grdList.SelectedRows=null;
					grdList.Selection.Clear();
					grdList.Rows[rw].Selected=true;
				}
				else{
//				rw=grdList.SelectedRow.Row;																		// aktuelle zeile
					if(grdList.Selection.Rows.Count>0){
						rw=grdList.Selection.Rows[0].Row;
						vCurrAdr.Modify(this);																				// adressnderungen einlesen
						vCurrAdr.Display(grdList,rw);																	// ..und anzeigen in liste
					}
				}
				vChanged=true;																								// adresse gendert
			}
		}


		/// <summary>event: contextmen ffnen</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void mnuListe_Popup(object sender, System.EventArgs e) {
//		bool lastRow=(grdList.SelectedRow.Row==grdList.Rows.Count-1);									// letzte zeile ?
//		bool lastRow=((grdList.Selection.Rows[0] as GridRow).Row==grdList.Rows.Count-1);									// letzte zeile ?
			bool lastRow=false;

			mnuCopy.Enabled=mnuCut.Enabled=mnuEdit.Enabled=mnuDelete.Enabled=!lastRow;		// enable/disable menuItem
			mnuPaste.Enabled=(Clipboard.GetDataObject().GetDataPresent(typeof(clsAdr)));	// paste dto.
		}

		/// <summary>event: menuItem 'cut'</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void mnuCut_Click(object sender, System.EventArgs e) {
			mnuCopy_Click(sender,e);																				// copy..
			mnuDelete_Click(sender,e);																			// ..and delete
		}

		/// <summary>event: menuItem copy</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void mnuCopy_Click(object sender, System.EventArgs e) {
			if(vCurrAdr!=null)																							// adresse ok ?
				Clipboard.SetDataObject((vCurrAdr as ICloneable).Clone());		// ..ins clipboard kopieren
		}

		/// <summary>event: menuItem paste</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void mnuPaste_Click(object sender, System.EventArgs e) {
			if(Clipboard.GetDataObject().GetDataPresent(typeof(clsAdr))){				// adresse im clipboard ?
				ICloneable	cln;
				clsAdr			adr;
				int					rw=grdList.Rows["rowLast"].Row;												// ..letzte zeile
			
				cln=(ICloneable)Clipboard.GetDataObject().GetData(typeof(clsAdr));// ..get it..
				adr=(clsAdr)cln.Clone();																					// ..kopie erzeugen
				grdList.AddRows(1,rw);																						// ..neue zeile einfgen
//			grdList.SelectedRows=null;
				adr.Display(grdList,rw);																					// ..an anzeigen
				grdList.Selection.Rows.Clear();
				grdList.Rows[rw].Selected=true;																		// ..und markieren
				vChanged=true;																										// ..adressen gendert
			}
		}

		/// <summary>event: adresse lschen</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void mnuDelete_Click(object sender, System.EventArgs e) {
//		grdList.Rows.Remove(grdList.SelectedRow);												// zeile lschen
			if(grdList.Selection.Rows.Count>0)
				if(grdList.Selection.Rows[0].Name!="rowLast")
					grdList.Rows.Remove(grdList.Selection.Rows[0]);
			grdList.Rows[grdList.FixedRowCount].Selected=true;							// erste zeile markieren
			vChanged=true;																									// adressen gendert
		}

		/// <summary>event: adresse neu</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void mnuNew_Click(object sender, System.EventArgs e) {
//		grdList.SelectedRows=null;																			// alle zeile markierung aus
			grdList.Selection.Clear();
			grdList.Rows["rowLast"].Selected=true;													// letzte zeile markieren
			txtVorname.Focus();																							// eingabe
		}

		/// <summary>event: adresse ndern</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void mnuEdit_Click(object sender, System.EventArgs e) {
			txtVorname.Focus();																							// warten auf eingebe
		}

		/// <summary>event: adressen sortieren</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void grdList_BeforeColumnSort(object sender, ppsGrid.BeforeColumnSortEventArgs e) {
			grdList.Rows.RemoveAt(grdList.Rows.Count-1);										// letzte Zeile entfernen
		}
		/// <summary>event: adressen sortieren ende</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void grdList_AfterColumnSort(object sender, ppsGrid.AfterColumnSortEventArgs e) {
			grdList.AddRows(1);																							// letzte zeile neu
			grdList.Rows[grdList.Rows.Count-1].Name="rowLast";							// ber name finden
//		grdList.SelectedRows=null;																			// alle markierung aus
			grdList.Selection.Clear();
			grdList.Rows[grdList.FixedRowCount].Selected=true;							// erste zeile markieren
		}

		/// <summary>event: zeile verschienen</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void grdList_BeforeRowMove(object sender, ppsGrid.BeforeRowMoveEventArgs e) {
			e.Cancel=(grdList.Rows[e.Row].Name=="rowLast");									// letzte zeile nicht mglich
		}

		/// <summary>event: Selektion gendert</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void grdList_AfterSelectionChange(object sender, ppsGrid.AfterSelectionChangeEventArgs e) {
			vCurrAdr=(clsAdr)grdList.Rows[e.Row].Tag;												// adresse holen
			if(vCurrAdr==null)																							// ok ?
				(new clsAdr()).Display(this);																	// ..anzeigen
			else
				vCurrAdr.Display(this);																				// lezte zeile, anzeige lschen
		}
	}

	[Serializable]
	class clsAdr:ICloneable{
		private string			vVorname,vNachname,vMittelfeld;
		private string			vStrasse,vStadt,vPostfach;
		private	int					vPlz;
		private string			vTelefon,vFax,vMobil,vInternet,vEmail;
		private DateTime		vGeburtstag;

		public clsAdr(){
		}
		public clsAdr(frmAdr frm){
			Modify(frm);
		}

		/// <summary>adresse kopieren</summary>
		/// <returns></returns>
		object ICloneable.Clone(){
			return(this.MemberwiseClone());
		}
		
		/// <summary>adresse im grid anzeige</summary>
		/// <param name="grd"></param>
		/// <param name="rw"></param>
		public void Display(Grid grd,int rw){
			string	str="",cr=System.Environment.NewLine;

			grd.Cells["colVorname",rw].Value=vVorname;											// colName verwenden wegen spalten verschieben
			grd.Cells["colNachname",rw].Value=vNachname;
			grd.Cells["colMittelfeld",rw].Value=vMittelfeld;

			grd.Cells["colStrasse",rw].Value=vStrasse;
			grd.Cells["colPLZ",rw].Value=(vPlz==0?"":vPlz.ToString());
			grd.Cells["colStadt",rw].Value=vStadt;
			grd.Cells["colPostfach",rw].Value=vPostfach;
			
			grd.Cells["colTelefon",rw].Value=vTelefon;
			grd.Cells["colFax",rw].Value=vFax;
			grd.Cells["colMobil",rw].Value=vMobil;
			grd.Cells["colInternet",rw].Value=vInternet;
			grd.Cells["colEMail",rw].Value=vEmail;
			
			grd.Cells["colGeburtstag",rw].Value=vGeburtstag;
			grd.Rows[rw].Tag=this;																					// adresse als userData speichern

			str+=vVorname+" "+vNachname+cr;
			str+=vStrasse+cr;
			str+=vPlz.ToString()+" "+vStadt;
			if(str.Length>5)
				grd.Rows[rw].ToolTipText=str;
			else
				grd.Rows[rw].ToolTipText=null;
		}

		/// <summary>adresse im formular anzeigen</summary>
		/// <param name="frm"></param>
		public void Display(frmAdr frm){
			frm.txtVorname.Text=vVorname;
			frm.txtNachname.Text=vNachname;
			frm.txtMittelfeld.Text=vMittelfeld;

			frm.txtStrasse.Text=vStrasse;
			frm.txtPLZ.Text=(vPlz==0?"":vPlz.ToString());
			frm.txtStadt.Text=vStadt;
			frm.txtPostfach.Text=vPostfach;

			frm.txtTelefon.Text=vTelefon;
			frm.txtFax.Text=vFax;
			frm.txtMobil.Text=vMobil;
			frm.txtInternet.Text=vInternet;
			frm.txtEmail.Text=vEmail;

			if(vGeburtstag.Ticks==0)
				frm.dteGeburtstag.Value=DateTime.Today;
			else
				frm.dteGeburtstag.Value=vGeburtstag;
		}

		/// <summary>adressnderungen</summary>
		/// <param name="frm"></param>
		public void Modify(frmAdr frm){
			vVorname=frm.txtVorname.Text;
			vNachname=frm.txtNachname.Text;
			vMittelfeld=frm.txtMittelfeld.Text;

			vStrasse=frm.txtStrasse.Text;
			vStadt=frm.txtStadt.Text;
			vPostfach=frm.txtPostfach.Text;

			try{
				vPlz=int.Parse(frm.txtPLZ.Text);
			}
			catch{
				vPlz=0;
			}

			vTelefon=frm.txtTelefon.Text;
			vFax=frm.txtFax.Text;
			vMobil=frm.txtMobil.Text;
			vInternet=frm.txtInternet.Text;
			vEmail=frm.txtEmail.Text;

			vGeburtstag=frm.dteGeburtstag.Value;
		}
	}
}
