using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Diagnostics;

namespace grdDemo.frm{
	public class clsGridCar{
		private string		vName;
		private int				vHersteller;
		private Color			vFarbe;
		private DateTime	vBaujahr;
		private Image		vBild;

		public clsGridCar(string nm,int hs,Color frb,DateTime bj,Image bld){
			vName=nm;
			vHersteller=hs;
			vFarbe=frb;
			vBaujahr=bj;
			vBild=bld;
		}
		public string		Name{get{return(vName);}}
		public int			Hersteller{get{return(vHersteller);}}
		public Color		Farbe{get{return(vFarbe);}}
		public DateTime Baujahr{get{return(vBaujahr);}}
		public Image		Bild{get{return(vBild);}}
		public override string ToString(){
			return(vName);
		}
	}
	/// <summary>
	/// Summary description for usrCar.
	/// </summary>
	public class usrCar : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.Label labName;
		private System.Windows.Forms.Label labStr;
		public System.Windows.Forms.TextBox txtName;
		private System.Windows.Forms.Label labBaujahr;
		public System.Windows.Forms.DateTimePicker dteBaujahr;
		private System.Windows.Forms.PictureBox picBild;
		private System.Windows.Forms.Button btnFarbe;
		public System.Windows.Forms.ComboBox cboHersteller;
		private System.Windows.Forms.Label labFarbe;
		private System.Windows.Forms.Panel pnlFarbe;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public usrCar()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			// TODO: Add any initialization after the InitForm call

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		public clsGridCar	myValue{
			get{return(new clsGridCar(txtName.Text,cboHersteller.SelectedIndex,pnlFarbe.BackColor,dteBaujahr.Value,picBild.Image));}
			set{
				txtName.Text=value.Name;
				cboHersteller.SelectedIndex=value.Hersteller;
				pnlFarbe.BackColor=value.Farbe;
				dteBaujahr.Value=value.Baujahr;
				picBild.Image=value.Bild;
			}
		}
		public override string	Text{
			get{return(txtName.Text);}
			set{
				Debugger.Break();
			}
		}
		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.labName = new System.Windows.Forms.Label();
			this.labStr = new System.Windows.Forms.Label();
			this.labFarbe = new System.Windows.Forms.Label();
			this.labBaujahr = new System.Windows.Forms.Label();
			this.txtName = new System.Windows.Forms.TextBox();
			this.cboHersteller = new System.Windows.Forms.ComboBox();
			this.dteBaujahr = new System.Windows.Forms.DateTimePicker();
			this.picBild = new System.Windows.Forms.PictureBox();
			this.btnFarbe = new System.Windows.Forms.Button();
			this.pnlFarbe = new System.Windows.Forms.Panel();
			this.SuspendLayout();
			// 
			// labName
			// 
			this.labName.Location = new System.Drawing.Point(0, 8);
			this.labName.Name = "labName";
			this.labName.Size = new System.Drawing.Size(44, 12);
			this.labName.TabIndex = 0;
			this.labName.Text = "Name";
			// 
			// labStr
			// 
			this.labStr.Location = new System.Drawing.Point(0, 32);
			this.labStr.Name = "labStr";
			this.labStr.Size = new System.Drawing.Size(56, 12);
			this.labStr.TabIndex = 0;
			this.labStr.Text = "Hersteller";
			// 
			// labFarbe
			// 
			this.labFarbe.Location = new System.Drawing.Point(0, 52);
			this.labFarbe.Name = "labFarbe";
			this.labFarbe.Size = new System.Drawing.Size(44, 12);
			this.labFarbe.TabIndex = 1;
			this.labFarbe.Text = "Farbe";
			// 
			// labBaujahr
			// 
			this.labBaujahr.Location = new System.Drawing.Point(0, 76);
			this.labBaujahr.Name = "labBaujahr";
			this.labBaujahr.Size = new System.Drawing.Size(44, 12);
			this.labBaujahr.TabIndex = 2;
			this.labBaujahr.Text = "Baujahr";
			// 
			// txtName
			// 
			this.txtName.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.txtName.Location = new System.Drawing.Point(48, 0);
			this.txtName.Name = "txtName";
			this.txtName.Size = new System.Drawing.Size(112, 20);
			this.txtName.TabIndex = 3;
			this.txtName.Text = "";
			// 
			// cboHersteller
			// 
			this.cboHersteller.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.cboHersteller.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboHersteller.Location = new System.Drawing.Point(48, 24);
			this.cboHersteller.Name = "cboHersteller";
			this.cboHersteller.Size = new System.Drawing.Size(112, 21);
			this.cboHersteller.Sorted = true;
			this.cboHersteller.TabIndex = 5;
			// 
			// dteBaujahr
			// 
			this.dteBaujahr.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.dteBaujahr.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dteBaujahr.Location = new System.Drawing.Point(48, 72);
			this.dteBaujahr.MinDate = new System.DateTime(1972, 1, 1, 0, 0, 0, 0);
			this.dteBaujahr.Name = "dteBaujahr";
			this.dteBaujahr.Size = new System.Drawing.Size(112, 20);
			this.dteBaujahr.TabIndex = 8;
			// 
			// picBild
			// 
			this.picBild.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.picBild.Location = new System.Drawing.Point(168, 4);
			this.picBild.Name = "picBild";
			this.picBild.Size = new System.Drawing.Size(128, 84);
			this.picBild.TabIndex = 9;
			this.picBild.TabStop = false;
			// 
			// btnFarbe
			// 
			this.btnFarbe.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.btnFarbe.Location = new System.Drawing.Point(136, 48);
			this.btnFarbe.Name = "btnFarbe";
			this.btnFarbe.Size = new System.Drawing.Size(24, 20);
			this.btnFarbe.TabIndex = 7;
			this.btnFarbe.Text = "...";
			this.btnFarbe.Click += new System.EventHandler(this.btnFarbe_Click);
			// 
			// pnlFarbe
			// 
			this.pnlFarbe.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.pnlFarbe.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlFarbe.Location = new System.Drawing.Point(48, 48);
			this.pnlFarbe.Name = "pnlFarbe";
			this.pnlFarbe.Size = new System.Drawing.Size(80, 20);
			this.pnlFarbe.TabIndex = 10;
			// 
			// usrCar
			// 
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.pnlFarbe,
																																	this.btnFarbe,
																																	this.picBild,
																																	this.dteBaujahr,
																																	this.cboHersteller,
																																	this.txtName,
																																	this.labBaujahr,
																																	this.labFarbe,
																																	this.labName,
																																	this.labStr});
			this.Name = "usrCar";
			this.Size = new System.Drawing.Size(300, 92);
			this.ResumeLayout(false);

		}
		#endregion

		private void btnFarbe_Click(object sender, System.EventArgs e) {
			ColorDialog	dlg=new ColorDialog();

			dlg.Color=pnlFarbe.BackColor;
			dlg.SolidColorOnly=true;
			if(dlg.ShowDialog()==DialogResult.OK)
				pnlFarbe.BackColor=dlg.Color;
			dlg.Dispose();
		}

	}
}
