using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Text;
using System.Diagnostics;

using System.Windows.Forms;
using ppsGrid;

namespace grdDemo.frm{
	public class frmCellSpan:System.Windows.Forms.Form{
		private ppsGrid.Grid grid;
		private ppsGrid.GridRow rowTitle;
		private System.Windows.Forms.Panel panel1;
		private ppsGrid.GridCol gridCol1;
		private ppsGrid.GridCol gridCol2;
		private ppsGrid.GridCol gridCol3;
		private ppsGrid.GridCol gridCol4;
		private ppsGrid.GridCol gridCol5;
		private ppsGrid.GridRow gridRow1;
		private ppsGrid.GridRow gridRow2;
		private ppsGrid.GridRow gridRow3;
		private ppsGrid.GridRow gridRow4;
		private ppsGrid.GridRow gridRow5;
		private ppsGrid.GridRow gridRow6;
		private ppsGrid.GridRow gridRow7;
		private System.ComponentModel.IContainer components = null;

		public frmCellSpan(){
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ){
			if(disposing)
				if (components != null) 
					components.Dispose();
			base.Dispose( disposing );
		}

		
		//		public void Init(){
		//			Random		rnd=new Random();
		//			int				cl,rw;
		//			string		s;
		//
		//			grid.AddRows(4);
		//			grid.Cols[0].Fixed=false;
		//
		//			foreach(GridCol c in grid.Cols)
		//				c.Width=20;
		//
		//			for(int c=0;c<10;c++){
		//				cl=rnd.Next(grid.FixedColCount,grid.Cols.Count);
		//				rw=rnd.Next(grid.FixedRowCount,grid.Rows.Count);
		//
		//				if(grid[cl,rw].BackColorCell!=Color.Cyan){
		//					grid[cl,rw].BackColorCell=Color.Cyan;
		//
		//					switch(rnd.Next(2)){
		//						case 0:
		//							grid[cl,rw].Value=rnd.Next(9000)+1000;
		//							break;
		//						case 1:
		//							grid[cl,rw].Value="Gabi";
		//							break;
		//					}
		//				}
		//			}
		//
		//			for(int r=0;r<grid.Rows.Count;r++){
		//				for(int c=0;c<grid.Cols.Count;c++){
		//					s=grid[c,r].Text;
		//					if(s==null||s==string.Empty)	s="    ";
		//					Debug.Write(grid.Cols[c].Width.ToString()+s+" ");
		//				}
		//				Debug.WriteLine("");
		//			}
		//		}


		public void Init(){
			Random		rnd=new Random();
			int				cl,rw;
			DateTime	dte=new DateTime(DateTime.Today.Year,1,1);

			string[]	str=new string[] {
																	 "Torsten Oberprieler",
																	 "Sacha Taugenicht",
																	 "Sabine Friedefreude",
																	 "Petra Mchtegern",
																	 "Monika Kannnichtmehr",
																	 "Thomas Eierkuchen",
																	 "Andreas Dampfschifffahrt",
																	 "Jo Bad",
																	 "Uwe Ein",
																	 "Jens Meier"
																 };

			grid.AddRows(500);																							// 500 Zeilen...
			for(int c=1000;c>0;c--){																				// 1000mal..
				cl=rnd.Next(grid.FixedColCount,grid.Cols.Count);							// ..Zufallszelle..
				rw=rnd.Next(grid.FixedRowCount,grid.Rows.Count);							// ..auswhlen

				switch(rnd.Next(3)){																					// zahl, string oder datum?
					case 0:
						grid[cl,rw].Value=rnd.Next(int.MaxValue);									// ..zahl
						break;
					case 1:
						grid[cl,rw].Value=str[rnd.Next(str.Length)];							// string
						break;
					case 2:																											// datum
						grid[cl,rw].Value=dte.AddDays(rnd.Next(365));
						grid[cl,rw].FormatString="dd.MM.yyyy";
						break;
				}
				grid[cl,rw].Tag=grid[cl,rw].Value;														// ..wert auch im "Tag" speichern
			}


			for(int c=0;c<10000;c++){																				// 10.000mal
				cl=rnd.Next(grid.FixedColCount,grid.Cols.Count);							// ..zufallszelle
				rw=rnd.Next(25,grid.Rows.Count);															// ..auswhlen
				if(rnd.Next(2)==0)																						// ..entweder auf NULL setzen
					grid[cl,rw].Value=null;
				else
					grid[cl,rw].Value=grid[cl,rw].Tag;													// ..oder Wert wieder herstellen
			}
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.grid = new ppsGrid.Grid();
			this.gridCol1 = new ppsGrid.GridCol();
			this.gridCol2 = new ppsGrid.GridCol();
			this.gridCol3 = new ppsGrid.GridCol();
			this.gridCol4 = new ppsGrid.GridCol();
			this.gridCol5 = new ppsGrid.GridCol();
			this.gridRow1 = new ppsGrid.GridRow();
			this.gridRow2 = new ppsGrid.GridRow();
			this.gridRow3 = new ppsGrid.GridRow();
			this.gridRow4 = new ppsGrid.GridRow();
			this.gridRow5 = new ppsGrid.GridRow();
			this.gridRow6 = new ppsGrid.GridRow();
			this.gridRow7 = new ppsGrid.GridRow();
			this.rowTitle = new ppsGrid.GridRow();
			this.panel1 = new System.Windows.Forms.Panel();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// grid
			// 
			this.grid.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.grid.BackColorCell = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(255)));
			this.grid.BackColorCellGradient = System.Drawing.Color.White;
			this.grid.BackColorColAlternate = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(224)), ((System.Byte)(192)));
			this.grid.BackColorFixedGradient = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(255)), ((System.Byte)(255)));
			this.grid.CellGradientMode = ppsGrid.eGradientMode.Horizontal;
			this.grid.CellHomeVisible = true;
			this.grid.CellPadding.All = 0;
			this.grid.CellSpan = true;
			this.grid.Cols.AddRange(new object[] {
																						 this.gridCol1,
																						 this.gridCol2,
																						 this.gridCol3,
																						 this.gridCol4,
																						 this.gridCol5});
			this.grid.Location = new System.Drawing.Point(4, 27);
			this.grid.Name = "grid";
			this.grid.Rows.AddRange(new object[] {
																						 this.gridRow1,
																						 this.gridRow2,
																						 this.gridRow3,
																						 this.gridRow4,
																						 this.gridRow5,
																						 this.gridRow6,
																						 this.gridRow7});
			this.grid.Scrollbar = ppsGrid.eScrollbar.Both;
			this.grid.Size = new System.Drawing.Size(719, 400);
			this.grid.TabIndex = 0;
			this.grid.KeyDown += new System.Windows.Forms.KeyEventHandler(this.grid_KeyDown);
			// 
			// gridCol1
			// 
			this.gridCol1.AutoNumber = true;
			this.gridCol1.BackColorCell = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.gridCol1.BackColorFixed = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(192)), ((System.Byte)(192)));
			this.gridCol1.BackColorFixedGradient = System.Drawing.Color.Gray;
			this.gridCol1.Fixed = true;
			this.gridCol1.Name = "gridCol1";
			this.gridCol1.Width = 60;
			this.gridCol1.WidthPercent = 20;
			// 
			// gridCol2
			// 
			this.gridCol2.BackColorFixed = System.Drawing.Color.Silver;
			this.gridCol2.BackColorFixedGradient = System.Drawing.Color.Red;
			this.gridCol2.Fixed = true;
			this.gridCol2.Name = "gridCol2";
			this.gridCol2.WidthPercent = 10;
			this.gridCol2.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// gridCol3
			// 
			this.gridCol3.BackColorCell = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.gridCol3.BackColorCellGradient = System.Drawing.Color.Yellow;
			this.gridCol3.BackColorFixed = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(192)), ((System.Byte)(192)));
			this.gridCol3.BackColorFixedGradient = System.Drawing.Color.CornflowerBlue;
			this.gridCol3.Name = "gridCol3";
			this.gridCol3.StringAlignHorz = ppsGrid.eContentAlign.Near;
			this.gridCol3.WidthPercent = 20;
			this.gridCol3.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// gridCol4
			// 
			this.gridCol4.Name = "gridCol4";
			this.gridCol4.StringAlignHorz = ppsGrid.eContentAlign.Center;
			this.gridCol4.WidthPercent = 30;
			this.gridCol4.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// gridCol5
			// 
			this.gridCol5.Name = "gridCol5";
			this.gridCol5.StringAlignHorz = ppsGrid.eContentAlign.Far;
			this.gridCol5.WidthPercent = 40;
			this.gridCol5.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// gridRow1
			// 
			this.gridRow1.BackColorFixed = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(224)), ((System.Byte)(192)));
			this.gridRow1.BackColorFixedGradient = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(192)), ((System.Byte)(128)));
			this.gridRow1.Fixed = true;
			this.gridRow1.Height = 32;
			this.gridRow1.Name = "gridRow1";
			// 
			// gridRow2
			// 
			this.gridRow2.Fixed = true;
			this.gridRow2.Height = 32;
			this.gridRow2.Name = "gridRow2";
			// 
			// gridRow3
			// 
			this.gridRow3.Height = 32;
			this.gridRow3.Name = "gridRow3";
			// 
			// gridRow4
			// 
			this.gridRow4.Height = 32;
			this.gridRow4.Name = "gridRow4";
			// 
			// gridRow5
			// 
			this.gridRow5.Height = 32;
			this.gridRow5.Name = "gridRow5";
			// 
			// gridRow6
			// 
			this.gridRow6.Height = 32;
			this.gridRow6.Name = "gridRow6";
			// 
			// gridRow7
			// 
			this.gridRow7.Height = 32;
			this.gridRow7.Name = "gridRow7";
			// 
			// rowTitle
			// 
			this.rowTitle.Fixed = true;
			this.rowTitle.Name = "rowTitle";
			// 
			// panel1
			// 
			this.panel1.Controls.AddRange(new System.Windows.Forms.Control[] {
																																				 this.grid});
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(724, 433);
			this.panel1.TabIndex = 3;
			// 
			// frmCellSpan
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(724, 433);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.panel1});
			this.Name = "frmCellSpan";
			this.Text = "Cell-Span";
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion


		private void grid_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e) {
			if(e.KeyCode==Keys.Back)
				grid[grid.FocusCell].Value=null;

			if(e.KeyCode==Keys.Space){
				string[]	str=new string[] {
																		 "Xorsten Oberprieler",
																		 "Xacha Taugenicht",
																		 "Xabine Friedefreude",
																		 "Xetra Mchtegern",
																		 "Xonika Kannnichtmehr",
																		 "Xhomas Eierkuchen",
																		 "Xndreas Dampfschifffahrt",
																		 "Xo Bad",
																		 "Xwe Ein",
																		 "Xens Meier"
																	 };
				GridCell	c=grid[grid.FocusCell];
				Random		rnd=new Random();
				DateTime	dte=new DateTime(DateTime.Today.Year,1,1);

				switch(rnd.Next(3)){
					case 0:
						c.Value=rnd.Next(int.MaxValue);
						break;
					case 1:
						c.Value=str[rnd.Next(str.Length)];
					switch(rnd.Next(3)){
						case 0:
							c.StringAlignHorz=eContentAlign.Near;
							break;
						case 1:
							c.StringAlignHorz=eContentAlign.Center;
							break;
						case 2:
							c.StringAlignHorz=eContentAlign.Far;
							break;
					}
						break;
					case 2:
						c.Value=dte.AddDays(rnd.Next(365));
						c.FormatString="dd.MM.yyyy";
						break;
				}
			}
		}
	}
}

